
 
	
module.exports =  function(RED) {
	 var redNode;
	 var twilioClient = require('twilio')(RED.settings.twilio.account, RED.settings.twilio.authtoken);
	 var twilioMessages = [];
	  var nodeSettings = RED.settings.twilio_number;
	  function getServiceURL(endpoint) {
		 return nodeSettings.baseurl+"/service/"+endpoint;
	}
	 function registerTwilioNumber(number) {
		RED.httpAdmin.post("/twilio-number/service/"+number.sid+"/ok", function(req, res) {
			console.log("Received a at Twilio Number text message", req.body);
			twilioMessages.push( req.body );
		 });
		RED.httpAdmin.post("/twilio-number/service/"+number.sid+"/fail", function(req, res) {
			console.log("Twilio Text message failed", req.body);
		});
	 }
	 twilioClient.incomingPhoneNumbers.list(function(err, data) {
		data.incomingPhoneNumbers.forEach(function(number) {	
			registerTwilioNumber(number);
		 });
		 RED.httpAdmin.get("/twilio-number/numbers", function(req, res) {
			res.json(data.incomingPhoneNumbers);
		 });
		RED.httpAdmin.post("/twilio-number/register", function(req, res) {
			var number = twilioClient.incomingPhoneNumbers(req.body.sid);
			console.log("Updating Twilio Number Registration", req.body.sid);
			 number.update({
				"smsUrl": getServiceURL(req.body.sid+"/ok"),
				"smsMethod": "POST",
				"smsFallbackUrl": getServiceURL(req.body.sid+"/fail")
			}, function(err, ok) {
				if (err) {
					res.status(500).send(err);
					return;
				}
				registerTwilioNumber(number);
				res.send("");
			});
		});
	});

	function TwilioNumber( config ) {
		redNode = this;
		RED.nodes.createNode(this, config);
		function sendAllMessages() {
			if ( twilioMessages.length > 0 ) {
				twilioMessages.forEach(function(twilioMessage) {
					 var message = {
						'topic': twilioMessage.From,
						'from': twilioMessage.To,
						'payload': twilioMessage.Body };
					redNode.log("Sending message");
					redNode.send( message );
					twilioMessages.splice(twilioMessages.indexOf(twilioMessage), 1);
				});
			}
			setTimeout(sendAllMessages, 0);
		}
		setTimeout(sendAllMessages, 0);
	}
	RED.nodes.registerType("twilio-number", TwilioNumber);
}
